<?php
/*
Plugin Name: Shopp Affiliate Integration
Version: v1.3
Plugin URI: http://www.tipsandtricks-hq.com/
Author: Ruhul Amin
Author URI: http://www.tipsandtricks-hq.com/
Description: This plugin integrates the WP Affiliate Platfrom with the Shopp plugin v1.2+
*/

add_filter('shopp_checkout_form', 'checkout_function_filter');
function checkout_function_filter( $checkout ) {
	$referrer = wp_aff_shopp_get_referrer();
	$referrer_string = "type=hidden&name=referrer&value=".$referrer;
	$checkout .= shopp('checkout','order-data',$referrer_string);    
    return $checkout;
}

function wp_aff_shopp_get_referrer()
{
	if (!empty($_SESSION['ap_id']))
	{
	    $referrer = $_SESSION['ap_id'];
	}
	else if (isset($_COOKIE['ap_id']))
	{
	    $referrer = $_COOKIE['ap_id'];
	}	
	return $referrer;
}

function wp_aff_shopp_process_commission( $Purchase )
{	
	global $Shopp;
	if (empty($Shopp)){
		wp_affiliate_log_debug("Error! Shopp affiliate integration - Could not retrieve the shopp object",false);
		return false;
	}
	$Purchase = $Shopp->Purchase; //alternatively use $Purchase = ShoppPurchase();
	
	//Get the sales data
    $sale_amount = $Purchase->subtotal; //$Order->total, $Order->shipping, $Order->tax
	$txn_id = $Purchase->txnid;
	$item_id = $Purchase->id;
	$buyer_email = $Purchase->email;
	$referrer = $Purchase->data['referrer'];
	wp_affiliate_log_debug("Shopp affiliate integration values: ".$sale_amount."|".$txn_id."|".$item_id."|".$buyer_email."|".$referrer,true);

    if (empty($referrer))
    {
        $referrer = wp_aff_shopp_get_referrer();
    }
	if (!empty($referrer))
	{
		if(defined('WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE') && WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE == '1'){
			wp_affiliate_log_debug("Checking details for the WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE option",true);
			if(!empty($buyer_email)){
				if(wp_aff_check_if_buyer_is_referrer($referrer,$buyer_email)){
					wp_affiliate_log_debug('The buyer ('.$buyer_email.') is the referrer ('.$referrer.') so this sale is NOT ELIGIBLE for generating any commission.',true);
					return true;
				}
			}
			else{
				 wp_affiliate_log_debug("Buyer email data is missing from the request so the plugin cannot verify the WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE option",true);
			}
		}	
		wp_affiliate_log_debug("Shopp affiliate integration - Referrer value: ".$referrer,true);	
	    wp_aff_award_commission($referrer,$sale_amount,$txn_id,$item_id,$buyer_email);
	}
	else
	{
	    //Not an affiliate conversion
	}
}
add_action('shopp_order_success','wp_aff_shopp_process_commission');
?>